
clear all
set more off
set matsize 5000

global path "C:\Users\yaya1\Dropbox\Fall2020\ECON338\Stata Conference\Conference3"

use "$path\WAGE2.dta"

/*
        1. Regression using matrix
		- Regress lwage on educ, age and sp_age
*/

gen sp_age=age*age

gen const=1

**make a matrix :  Define Y
mkmat lwage, matrix(Y) 

** Define X
mkmat educ age sp_age const, matrix(X) 

** Use the formula to get b and sd
matrix b = invsym(X'*X) * X'*Y
mat list b

**Predict errors
matrix eps_e = (Y-X*b)

**Calculate variance of errors
matrix var_e = eps_e'*eps_e

matrix var_b = vecdiag(invsym(X'*X)*var_e)
mat list var_b

**Verify
reg lwage educ age sp_age
mat list b

/*
        1. Regression using  IV
*/

reg lwage educ age sp_age
est store reg_ols

*First stage
reg educ sibs age sp_age
predict educ_hat
est store first_step

** Second stage
reg lwage educ_hat age sp_age   
est store two_step

**Reduced form
reg lwage sibs age sp_age 
est store reduced_form

*** ivreg command
ivregress 2sls lwage age sp_age   (educ = sibs)
est store IV_command

*** ivreg command
ivregress 2sls lwage age sp_age   (educ = sibs), vce(robust)
est store IV_command_robust

**Matrix
mkmat sibs age sp_age const,mat(Z)
matrix  b_iv = inv(Z'*X)*(Z'*Y)

outreg2 [reg_ols  IV_command IV_command_robust] using  "$path\IV_results.xls", word replace 

outreg2 [reg_ols two_step  IV_command ] using  "$path\IV_results.xls",  word replace 

** two endogenous regressors, y2 and y3 instrumented by z1 and z2
ivregress 2sls y1 x1 (y3 = z1)

ivregress 2sls y1 x1 (y2 y3 = z1 z2), vce(robust)
